| Fns requiring  ` R , the Root dictionary .  R is saved as 
| Author: Bob Armstrong / www.CoSy.com
| Reva's license terms also apply to this file.
| Sat.May,20070526 

cr ." | Derived begin | " 
| Words requiring ' R , Root , list
| ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 

." Help \\/ " cr | \/ |
| \/ \/ | CoSy Help Words | \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ |
 
: (CShelp) ( str file -- occurrences ) F> emptyLn toksplt   
   swap con dup i# if { "nl swap cL } eachm then ;
 
: CShelpFul ( str -- refs ) | searches source files listed in 
| `( sys CoSySource )` for str and returns list of files searched 
| and source between preceding and succeeding blank lines containing  str .
  [ R ` sys v@ ` CoSySource v@ ] literal
  { >r> (CShelp) r> swap cL } eachright ;

| \/ |  | Main Help function . Return lines , delimited by empty lines 
 		| in files listed in |  ` sys Dv@ ` CoSySource v@  |
 		| which contain the phase passed

: :pad s" : " "bl ,L braket ; 	| 20201128 | and incorporated \/ |
: :?? :pad 	| note fall thru to  ' ?? . return only def | 20190518
: ?? CShelpFul >aux+> dup ['] rho 'm ,/ i1 >i & at refs+> aux- refs-ok>  ; 

| ( script name -- :def; ) 	| find & return just definition in script 
: def --aba >a :pad ss1st a> swap cut >a> s"  ; " ss1st 2 _i +i a> swap take ;
| been needing this verb for a long time | 20201128 

." Help /\\ " cr | /\ |

| Returns only those file in which the phrase was found

| /\ /\ | CoSy Help System | /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ |

| \/ \/ | miscellaneous fns | \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ |

| \/ save a timestamped clone of the current environment \/ |
: saveTSclone R lst>str  CoSyStartFile ymdhm cL s" .csy" cL >F ; | was COSYSTARTFILE 
| originally in ` script0 | 20161020 | 
| 20181227 | modernized becaus of bombing 20190820 |


| \/ | added here because requires ' .. defined in ./CoSy/SaveRestore.f  | \/ |
| convenient for seeing items around a found item . 
: _-+ _i : -+ .. 2 _i *i iota swap -i ['] +i 'L ;
| eg: |  i( 17 19 41 45 )i  5 _-+

| /\ /\ | miscellaneous fns | /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ |

| \/ \/ | Accounting tools  | \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ \/ |
| Accounting is one of the highest value uses for any computing language
| If you are good at number crunching , the numbers with the greatest return
| on crunching are ones with currency symbols attached .
| That's why , despite one early APL company being named ` STSC	for
| Scientific Time Sharing Company , even its major market was complex financial
| applications in global money center cities .

| I currently keep a simple list :
|   `( TimeStamp From To amount notes )` 	| Account Header
| constructed by lines like 
|    (' 20181015. _f ` PSBT ` IREA  f( 136.67 10 )f  s" acnts -792 -787 " ')
| to give an example with multiple amounts to be summed 
| 
| I then append these to a ` LedgerList in R . 
| here's a word specific to my current use , here for convenience
 

: LL_cL ( ledgerItem -- ) enc ` LedgerList  Dv_cL ;
| append enclosed list to ledger  | 20180925 |
 
| eg: 
|  (' 20180909.1523 _f ` PSBT ` visa  337.34 _f  s" pif " ') LL_cL
| to post an entery directly to ` LedgerList .

| /\ /\ | Accounting tools | /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ |

." | Derived end | "